3 # $Id: configure,v 1.55 2017/01/12 15:45:05 schwarze Exp $
5 # Copyright (c) 2014, 2015, 2016 Ingo Schwarze <schwarze@openbsd.org>
7 # Permission to use, copy, modify, and distribute this software for any
8 # purpose with or without fee is hereby granted, provided that the above
9 # copyright notice and this permission notice appear in all copies.
11 # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
12 # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
13 # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
14 # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
15 # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
16 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
17 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
21 [ -w config.log
] && mv config.log config.log.old
22 [ -w config.h
] && mv config.h config.h.old
24 # Output file descriptor usage:
25 # 1 (stdout): config.h, Makefile.local
26 # 2 (stderr): original stderr, usually to the console
30 echo "config.log: writing..."
32 # --- default settings -------------------------------------------------
33 # Initialize all variables here,
34 # such that nothing can leak in from the environment.
36 MANPATH_DEFAULT
="/usr/share/man:/usr/X11R6/man:/usr/local/man"
40 CC
=`printf "all:\\n\\t@echo \\\$(CC)\\n" | env -i make -sf -`
41 CFLAGS
="-g -W -Wall -Wmissing-prototypes -Wstrict-prototypes -Wwrite-strings"
42 CFLAGS
="${CFLAGS} -Wno-unused-parameter"
57 HAVE_FTS_COMPARE_CONST
=
95 BINM_APROPOS
="apropos"
96 BINM_MAKEWHATIS
="makewhatis"
101 MANM_MANCONF
="man.conf"
113 # --- manual settings from configure.local -----------------------------
115 if [ -r .
/configure.
local ]; then
116 echo "configure.local: reading..." 1>&2
117 echo "configure.local: reading..." 1>&3
118 cat .
/configure.
local 1>&3
121 echo "configure.local: no (fully automatic configuration)" 1>&2
122 echo "configure.local: no (fully automatic configuration)" 1>&3
126 # --- tests for config.h ----------------------------------------------
128 COMP
="${CC} ${CFLAGS} -Wno-unused -Werror"
130 # Check whether this HAVE_ setting is manually overridden.
131 # If yes, use the override, if no, do not decide anything yet.
132 # Arguments: lower-case test name, manual value
134 [ -z "${3}" ] && return 1
135 echo "${1}: manual (HAVE_${2}=${3})" 1>&2
136 echo "${1}: manual (HAVE_${2}=${3})" 1>&3
141 # Run a single autoconfiguration test.
142 # In case of success, enable the feature.
143 # In case of failure, do not decide anything yet.
144 # Arguments: lower-case test name, upper-case test name, additional CFLAGS
146 cat 1>&3 << __HEREDOC__
148 ${COMP} -o test-${1} test-${1}.c ${3}
151 if ${COMP} -o "test-${1}" "test-${1}.c" ${3} 1>&3 2>&3; then
152 echo "${1}${3}: ${CC} succeeded" 1>&3
154 echo "${1}${3}: ${CC} failed with $?" 1>&3
159 if .
/test-${1} 1>&3 2>&3; then
160 echo "${1}${3}: yes" 1>&2
161 echo "${1}${3}: yes" 1>&3
167 echo "${1}${3}: execution failed with $?" 1>&3
174 # Run a complete autoconfiguration test, including the check for
175 # a manual override and disabling the feature on failure.
176 # Arguments: lower case name, upper case name, additional CFLAGS
178 eval _manual
=\
${HAVE_${2}}
179 ismanual
"${1}" "${2}" "${_manual}" && return 0
180 singletest
"${1}" "${2}" "${3}" && return 0
181 echo "${1}${3}: no" 1>&2
186 # Select a UTF-8 locale.
188 [ -n "${HAVE_WCHAR}" ] && [ "${HAVE_WCHAR}" -eq 0 ] && return 0
189 ismanual UTF8_LOCALE UTF8_LOCALE
"$UTF8_LOCALE" && return 0
190 echo "UTF8_LOCALE: testing..." 1>&3
191 UTF8_LOCALE
=`locale -a | grep -i '^en_US\.UTF-*8$' | head -n 1`
192 if [ -z "${UTF8_LOCALE}" ]; then
193 UTF8_LOCALE
=`locale -a | grep -i '\.UTF-*8' | head -n 1`
194 [ -n "${UTF8_LOCALE}" ] || return 1
196 echo "UTF8_LOCALE=${UTF8_LOCALE}" 1>&2
197 echo "UTF8_LOCALE=${UTF8_LOCALE}" 1>&3
203 # --- library functions ---
204 runtest dirent
-namlen DIRENT_NAMLEN
|| true
205 runtest be32toh ENDIAN
|| true
206 runtest be32toh SYS_ENDIAN
-DSYS_ENDIAN || true
207 runtest EFTYPE EFTYPE
|| true
208 runtest err ERR
|| true
209 runtest getline GETLINE
|| true
210 runtest getsubopt GETSUBOPT
|| true
211 runtest isblank ISBLANK
|| true
212 runtest mkdtemp MKDTEMP
|| true
213 runtest ntohl NTOHL
|| true
214 runtest PATH_MAX PATH_MAX
|| true
215 runtest pledge PLEDGE
|| true
216 runtest sandbox_init SANDBOX_INIT
|| true
217 runtest progname PROGNAME
|| true
218 runtest reallocarray REALLOCARRAY
|| true
219 runtest rewb
-bsd REWB_BSD
|| true
220 runtest rewb
-sysv REWB_SYSV
|| true
221 runtest strcasestr STRCASESTR
|| true
222 runtest stringlist STRINGLIST
|| true
223 runtest strlcat STRLCAT
|| true
224 runtest strlcpy STRLCPY
|| true
225 runtest strptime STRPTIME
|| true
226 runtest strsep STRSEP
|| true
227 runtest strtonum STRTONUM
|| true
228 runtest vasprintf VASPRINTF
|| true
230 if [ ${HAVE_ENDIAN} -eq 0 -a \
231 ${HAVE_SYS_ENDIAN} -eq 0 -a \
232 ${HAVE_NTOHL} -eq 0 ]; then
233 echo "FATAL: no endian conversion functions found" 1>&2
234 echo "FATAL: no endian conversion functions found" 1>&3
238 if ismanual fts FTS
${HAVE_FTS}; then
239 HAVE_FTS_COMPARE_CONST
=0
240 elif runtest fts FTS_COMPARE_CONST
-DFTS_COMPARE_CONST; then
243 runtest fts FTS
|| true
246 # --- wide character and locale support ---
248 runtest wchar WCHAR
-DUTF8_LOCALE=\"${UTF8_LOCALE}\" || true
251 echo "wchar: no (no UTF8_LOCALE)" 1>&2
252 echo "wchar: no (no UTF8_LOCALE)" 1>&3
256 if [ -n "${LD_NANOSLEEP}" ]; then
257 runtest nanosleep NANOSLEEP
"${LD_NANOSLEEP}" || true
258 elif singletest nanosleep NANOSLEEP
; then
260 elif runtest nanosleep NANOSLEEP
"-lrt"; then
263 if [ "${HAVE_NANOSLEEP}" -eq 0 ]; then
264 echo "FATAL: nanosleep: no" 1>&2
265 echo "FATAL: nanosleep: no" 1>&3
270 if ismanual ohash OHASH
"${HAVE_OHASH}"; then
272 elif [ -n "${LD_OHASH}" ]; then
273 runtest ohash OHASH
"${LD_OHASH}" || true
274 elif singletest ohash OHASH
; then
276 elif runtest ohash OHASH
"-lutil"; then
279 if [ "${HAVE_OHASH}" -eq 0 ]; then
284 LDADD
="${LDADD} ${LD_NANOSLEEP} ${LD_OHASH} -lz"
285 echo "LDADD=\"${LDADD}\"" 1>&2
286 echo "LDADD=\"${LDADD}\"" 1>&3
289 # --- write config.h ---
295 #error "Do not use C++. See the INSTALL file."
298 #if !defined(__GNUC__) || (__GNUC__ < 4)
299 #define __attribute__(x)
302 #if defined(__linux__) || defined(__MINT__)
303 #define _GNU_SOURCE /* See test-*.c what needs this. */
308 [ ${HAVE_GETLINE} -eq 0 -o ${HAVE_REALLOCARRAY} -eq 0 -o \
309 ${HAVE_STRLCAT} -eq 0 -o ${HAVE_STRLCPY} -eq 0 ] \
310 && echo "#include <sys/types.h>"
311 [ ${HAVE_VASPRINTF} -eq 0 ] && echo "#include <stdarg.h>"
312 [ ${HAVE_GETLINE} -eq 0 ] && echo "#include <stdio.h>"
315 echo "#define MAN_CONF_FILE \"/etc/${MANM_MANCONF}\""
316 echo "#define MANPATH_DEFAULT \"${MANPATH_DEFAULT}\""
317 [ -n "${OSNAME}" ] && echo "#define OSNAME \"${OSNAME}\""
318 [ -n "${UTF8_LOCALE}" ] && echo "#define UTF8_LOCALE \"${UTF8_LOCALE}\""
319 [ -n "${HOMEBREWDIR}" ] && echo "#define HOMEBREWDIR \"${HOMEBREWDIR}\""
320 [ ${HAVE_EFTYPE} -eq 0 ] && echo "#define EFTYPE EINVAL"
321 [ ${HAVE_PATH_MAX} -eq 0 ] && echo "#define PATH_MAX 4096"
322 if [ ${HAVE_ENDIAN} -eq 0 -a ${HAVE_SYS_ENDIAN} -eq 0 ]; then
323 echo "#define be32toh ntohl"
324 echo "#define htobe32 htonl"
328 #define HAVE_DIRENT_NAMLEN ${HAVE_DIRENT_NAMLEN}
329 #define HAVE_ENDIAN ${HAVE_ENDIAN}
330 #define HAVE_ERR ${HAVE_ERR}
331 #define HAVE_FTS ${HAVE_FTS}
332 #define HAVE_FTS_COMPARE_CONST ${HAVE_FTS_COMPARE_CONST}
333 #define HAVE_GETLINE ${HAVE_GETLINE}
334 #define HAVE_GETSUBOPT ${HAVE_GETSUBOPT}
335 #define HAVE_ISBLANK ${HAVE_ISBLANK}
336 #define HAVE_MKDTEMP ${HAVE_MKDTEMP}
337 #define HAVE_NTOHL ${HAVE_NTOHL}
338 #define HAVE_PLEDGE ${HAVE_PLEDGE}
339 #define HAVE_PROGNAME ${HAVE_PROGNAME}
340 #define HAVE_REALLOCARRAY ${HAVE_REALLOCARRAY}
341 #define HAVE_REWB_BSD ${HAVE_REWB_BSD}
342 #define HAVE_REWB_SYSV ${HAVE_REWB_SYSV}
343 #define HAVE_SANDBOX_INIT ${HAVE_SANDBOX_INIT}
344 #define HAVE_STRCASESTR ${HAVE_STRCASESTR}
345 #define HAVE_STRINGLIST ${HAVE_STRINGLIST}
346 #define HAVE_STRLCAT ${HAVE_STRLCAT}
347 #define HAVE_STRLCPY ${HAVE_STRLCPY}
348 #define HAVE_STRPTIME ${HAVE_STRPTIME}
349 #define HAVE_STRSEP ${HAVE_STRSEP}
350 #define HAVE_STRTONUM ${HAVE_STRTONUM}
351 #define HAVE_SYS_ENDIAN ${HAVE_SYS_ENDIAN}
352 #define HAVE_VASPRINTF ${HAVE_VASPRINTF}
353 #define HAVE_WCHAR ${HAVE_WCHAR}
354 #define HAVE_OHASH ${HAVE_OHASH}
356 #define BINM_APROPOS "${BINM_APROPOS}"
357 #define BINM_MAKEWHATIS "${BINM_MAKEWHATIS}"
358 #define BINM_MAN "${BINM_MAN}"
359 #define BINM_SOELIM "${BINM_SOELIM}"
360 #define BINM_WHATIS "${BINM_WHATIS}"
364 if [ ${HAVE_ERR} -eq 0 ]; then
365 echo "extern void err(int, const char *, ...);"
366 echo "extern void errx(int, const char *, ...);"
367 echo "extern void warn(const char *, ...);"
368 echo "extern void warnx(const char *, ...);"
371 [ ${HAVE_GETLINE} -eq 0 ] && \
372 echo "extern ssize_t getline(char **, size_t *, FILE *);"
374 [ ${HAVE_GETSUBOPT} -eq 0 ] && \
375 echo "extern int getsubopt(char **, char * const *, char **);"
377 [ ${HAVE_ISBLANK} -eq 0 ] && \
378 echo "extern int isblank(int);"
380 [ ${HAVE_MKDTEMP} -eq 0 ] && \
381 echo "extern char *mkdtemp(char *);"
383 if [ ${HAVE_PROGNAME} -eq 0 ]; then
384 echo "extern const char *getprogname(void);"
385 echo "extern void setprogname(const char *);"
388 [ ${HAVE_REALLOCARRAY} -eq 0 ] && \
389 echo "extern void *reallocarray(void *, size_t, size_t);"
391 [ ${HAVE_STRCASESTR} -eq 0 ] && \
392 echo "extern char *strcasestr(const char *, const char *);"
394 [ ${HAVE_STRLCAT} -eq 0 ] && \
395 echo "extern size_t strlcat(char *, const char *, size_t);"
397 [ ${HAVE_STRLCPY} -eq 0 ] && \
398 echo "extern size_t strlcpy(char *, const char *, size_t);"
400 [ ${HAVE_STRSEP} -eq 0 ] && \
401 echo "extern char *strsep(char **, const char *);"
403 [ ${HAVE_STRTONUM} -eq 0 ] && \
404 echo "extern long long strtonum(const char *, long long, long long, const char **);"
406 [ ${HAVE_VASPRINTF} -eq 0 ] && \
407 echo "extern int vasprintf(char **, const char *, va_list);"
409 echo "config.h: written" 1>&2
410 echo "config.h: written" 1>&3
412 # --- tests for Makefile.local -----------------------------------------
414 exec > Makefile.
local
416 [ -z "${BINDIR}" ] && BINDIR
="${PREFIX}/bin"
417 [ -z "${SBINDIR}" ] && SBINDIR
="${PREFIX}/sbin"
418 [ -z "${INCLUDEDIR}" ] && INCLUDEDIR
="${PREFIX}/include/mandoc"
419 [ -z "${LIBDIR}" ] && LIBDIR
="${PREFIX}/lib/mandoc"
420 [ -z "${MANDIR}" ] && MANDIR
="${PREFIX}/man"
422 [ -z "${HTDOCDIR}" ] && HTDOCDIR
="${WWWPREFIX}/htdocs"
423 [ -z "${CGIBINDIR}" ] && CGIBINDIR
="${WWWPREFIX}/cgi-bin"
425 [ -z "${INSTALL_PROGRAM}" ] && INSTALL_PROGRAM
="${INSTALL} -m 0555"
426 [ -z "${INSTALL_LIB}" ] && INSTALL_LIB
="${INSTALL} -m 0444"
427 [ -z "${INSTALL_MAN}" ] && INSTALL_MAN
="${INSTALL} -m 0444"
428 [ -z "${INSTALL_DATA}" ] && INSTALL_DATA
="${INSTALL} -m 0444"
431 [ ${BUILD_CGI} -gt 0 ] && BUILD_TARGETS
="cgi-build"
433 [ ${INSTALL_LIBMANDOC} -gt 0 ] && INSTALL_TARGETS
="lib-install"
434 [ ${BUILD_CGI} -gt 0 ] && INSTALL_TARGETS
="${INSTALL_TARGETS} cgi-install"
437 BUILD_TARGETS = ${BUILD_TARGETS}
438 INSTALL_TARGETS = ${INSTALL_TARGETS}
447 INCLUDEDIR = ${INCLUDEDIR}
450 WWWPREFIX = ${WWWPREFIX}
451 HTDOCDIR = ${HTDOCDIR}
452 CGIBINDIR = ${CGIBINDIR}
453 BINM_APROPOS = ${BINM_APROPOS}
454 BINM_MAKEWHATIS = ${BINM_MAKEWHATIS}
455 BINM_MAN = ${BINM_MAN}
456 BINM_SOELIM = ${BINM_SOELIM}
457 BINM_WHATIS = ${BINM_WHATIS}
458 MANM_MAN = ${MANM_MAN}
459 MANM_MANCONF = ${MANM_MANCONF}
460 MANM_MDOC = ${MANM_MDOC}
461 MANM_ROFF = ${MANM_ROFF}
462 MANM_EQN = ${MANM_EQN}
463 MANM_TBL = ${MANM_TBL}
465 INSTALL_PROGRAM = ${INSTALL_PROGRAM}
466 INSTALL_LIB = ${INSTALL_LIB}
467 INSTALL_MAN = ${INSTALL_MAN}
468 INSTALL_DATA = ${INSTALL_DATA}
471 echo "Makefile.local: written" 1>&2
472 echo "Makefile.local: written" 1>&3